# -*- coding:utf-8 -*-
import sys
from os.path import isfile
from configobj import ConfigObj


conffile = "/etc/arv/arv.conf"
config = ConfigObj(conffile)
try:
    config = ConfigObj(conffile)
except Exception, e:
    print "ERROR: --- unable to load configuration file ---"
    sys.exit(1)

# configuration file
# internale sqlite database
sqlite_database = config.get('sqlite_database', '/var/lib/arv/db/sphynxdb.sqlite')
strongswan_database = config.get('strongswan_database', '/etc/ipsec.d/ipsec.db')
ipsec_tmp_path = config.get('ipsec_tmp_path', '/root/tmp/ConfIpsec')
strongswan_databases_directory = config.get('strongswan_databases_directory', '/var/lib/arv/nodeconf/')

arv_address_ip = config.get('arv_address_ip', None)
arv_address_ip_private = config.get('arv_address_ip_private', None)

ssl_dir = config.get('ssl_dir', '/var/lib/arv/CA')
ca_conf_file = config.get('ca_conf_file', '/etc/eole/ssl/ca-sphynx.conf')
conf_file_orig = config.get('conf_file_orig', '/etc/eole/ssl/certif-vpn.conf')
ssl_default_cert_time = config.get('ssl_default_cert_time', '1825')
x509_default_key_bits = config.get('x509_default_key_bits', '2048')

arv_port = int(config.get('arv_port', '8088'))
arv_ssl = config.get('arv_ssl', "enable")
arv_key = config.get('arv_crt', '/etc/ssl/certs/eole.key')
arv_crt = config.get('arv_crt', '/etc/ssl/certs/eole.crt')

arv_static_path = config.get('arv_static_path', '/usr/share/arv/static')

allow_user = config.get('allow_user', None)

log_file = config.get('error_log', '/var/log/arv/error.log')
#log_level: debug, info, warning, error, critical
log_level = config.get('log_level', 'debug')

key2keyid_path = "/usr/sbin/key2keyid"
if not isfile(key2keyid_path):
    raise ValueError("strongswan script %s not found"% key2keyid_path)
id2sql_path = "/usr/sbin/id2sql"
if not isfile(id2sql_path):
    raise ValueError("strongswan script %s not found"% id2sql_path)
bin2sql_path = "/usr/sbin/bin2sql"
if not isfile(bin2sql_path):
    raise ValueError("strongswan script %s not found"% bin2sql_path)

# default values in tables
ChildConfig_lifetime = config.get('ChildConfig_lifetime', 1200)
ChildConfig_rekeytime = config.get('ChildConfig_rekeytime', 1020)
ChildConfig_jitter = config.get('ChildConfig_jitter', 180)
ChildConfig_hostaccess = config.get('ChildConfig_hostaccess', 1)
ChildConfig_mode = config.get('ChildConfig_mode', 2)
ChildConfig_close_action = config.get('ChildConfig_close_action', 0)
ChildConfig_ipcomp = config.get('ChildConfig_ipcomp', 0)
IkeConfig_certreq = config.get('IkeConfig_certreq', 1)
IkeConfig_force_encap = config.get('IkeConfig_force_encap', 0)
PeerConfig_ike_version = config.get('PeerConfig_ike_version', 2)
PeerConfig_cert_policy = config.get('PeerConfig_cert_policy', 1)
PeerConfig_uniqueid = config.get('PeerConfig_uniqueid', 1)
PeerConfig_auth_method = config.get('PeerConfig_auth_method', 1)
PeerConfig_eap_type = config.get('PeerConfig_eap_type', 0)
PeerConfig_eap_vendor = config.get('PeerConfig_eap_vendor', 0)
PeerConfig_keyingtries = config.get('PeerConfig_keyingtries', 1)
PeerConfig_rekeytime = config.get('PeerConfig_rekeytime', 0)
PeerConfig_reauthtime = config.get('PeerConfig_reauthtime', 3600)
PeerConfig_jitter = config.get('PeerConfig_jitter', 180)
PeerConfig_overtime = config.get('PeerConfig_overtime', 300)
PeerConfig_mobike = config.get('PeerConfig_mobike', 1)
PeerConfig_dpd_delay = config.get('PeerConfig_dpd_delay', 120)
PeerConfig_mediation = config.get('PeerConfig_mediation', 0)
PeerConfig_mediated_by = config.get('PeerConfig_mediated_by', 0)
PeerConfig_peer_id = config.get('PeerConfig_peer_id', 0)
CertificateDistributionPoints_uri = config.get('CertificateDistributionPoints_uri', None)
CACert = config.get('CACert', None)

### Proposals id table
proposals = {1:'aes128-sha256-modp2048',
             2:'aes192-sha384-modp3072',
             3:'aes128gcm128',
             4:'aes192gcm128'
            }
ike_cfg_proposal = { 1:[(1,1), (2,2)] }
child_cfg_proposal = { 1:[(1,3)],
#                       2:[(1,4)],
#                       3:[(1,3),(2,4)]
                     }

test_rvp = """
#!/bin/sh
# DEB:
echo -n "Réseau Virtuel Privé :"
if [  -e /var/lock/subsys/ipsec ]
then
    fping %s
else
    echo "Le tunnel n'est pas actif!"
    exit 2
fi
# FIN:
""" % arv_address_ip_private
